import Lib;
import Protocol;
using MAll;

class Building  extends EL{//}
	
	public var block:Bool;
	public var hex:Hex;
	public var ladder:EL;

	public var monster:EL;
	public var life:Int;

	public var timer:Int;
	public var data:DataBuilding;
	public var guardians:Array<Ent>;
	
	public var bdata:DataBonus;
	
	public function new(type, hex) {
		super();
		guardians = [];
		
		if ( hex != null ) setHex(hex);
		if ( type != null ) setType(type);
		
		
		Game.me.buildings.push(this);
		timer = data.cooldown -1;
		
		life = Gameplay.BLOCK_LIFE;
		block = true;
		majData();
	}
	
	public function setType(t) {
		data = Data.BUILDINGS[Type.enumIndex(t)];
		goto(Type.enumIndex(data.id), "buildings");
		
		switch(data.id) {
			case CASTLE :
				new Building( LADDER, hex.getSwap() );
				
			
			case ARCHER :
				monster = new EL();
				monster.goto("archer");
				addChild(monster);
				monster.y = -21;
				
			case SORCERER :
				monster = new EL();
				monster.goto("sorcerer");
				addChild(monster);
				monster.y = -8;
				
			case GRAVEYARD :
				block = false;
				
			default :
		}

	}
	public function setHex(h) {
		
		if ( hex != null ) {
			hex.building = null;
			remove();
		}
		
		hex = h;
		hex.building = this;
		hex.center(this);
		hex.level.dm.add(this, DP_ENTS);
		//hex.tile.addChild(tile);
	}

	public function majData() {
		if ( data.id == GRAVEYARD && Game.me.have(GRAVEYARD_WALL)) {
			goto(0, "alt_buildings");
			block = true;
		}
	}
	
	public function update() {
		timer++;
		
		if ( timer > data.cooldown && data.cooldown >= 0 ) (data.spawn == null?tryShoot:spawn)();
		
		/*
		if ( data.id == GRAVEYARD && Main.t % 40 == 0 && Game.me.have(STENCH) ) {
			var a = hex.getEnts(1);
			for ( e in a ) if ( e.team == 1 ) {
				
				new fx.Fade(e.skin, true, 0x008800);
				
				var el = new EL();
				el.play("gas");
				//el.anim.playSpeed = 0.5 + Math.random();
				el.randomFlip();
				
				var p = new fx.Part(el);
				el.anim.onFinish = el.kill;
				p.setPos( e.x + Std.random(7) - 3, e.y - 6 - Std.random(8) );
				p.vy = -Math.random();
				
				e.hex.level.dm.add(el, DP_FX);
				
				e.hit(1, 0, true);
			}
		}
		*/
		
		
	}
	
	function tryShoot() {
		var range = data.range;
		if ( data.id == ARCHER && Game.me.have(SPYGLASS) ) range = Std.int( range * 1.5);
		
		var ray = Math.round(range / (Hex.RAY * 2));
		var opp = getNearestOpponent(ray);
		if ( opp != null && getDist(opp) < range ) {
			shoot(opp);
			if ( data.id == ARCHER && Game.me.have(DOUBLE_ARROW) ) new fx.Wait(12, shoot.bind(opp) );
		}

	}
	
	public function getDist(e:Ent) {
		var dx = e.x - x;
		var dy = e.y - y;
		return Math.sqrt(dx * dx + dy * dy);
	}
	

	function shoot(opp:Ent) {
		
		timer = 0;
		var anim = null;
		var  id = 0;
		var  jump = 0;
		if ( data.id == ARCHER ) {
			anim = "archer";
			jump = 32;
		}
		if ( data.id == SORCERER ) {
			anim = "sorcerer";
			id = 1;
		}
		
		monster.play(anim);
		monster.anim.loop = false;		
		monster.scaleX = (opp.x - x) < 0?-1:1;
		
		var damage = data.damage;
		if ( data.id == ARCHER  ) damage+=Game.me.numHave(SHARPEN);
		
		var launch = function() {
			Main.playSion(anim,0,hex.level);
			
			
			var e = new fx.Projectile(hex.level, id, damage, x, y - 14, opp);
			e.pierce = data.id == SORCERER;
			e.jump = jump;			
		}

		new fx.Wait(8,launch);
		
		
	}
	
	
	function spawn() {
		var limit = data.damage;
		if ( data.id == GRAVEYARD  ) limit += Game.me.numHave(MORE_ZOMBIES);
		if ( data.id == GRAVEYARD && Game.me.have(STENCH) ) limit --;
		
		if ( guardians.length >= limit ) return;
		var mon = new Ent(data.spawn,hex);
		mon.spawner = this;
		guardians.push(mon);
		timer = 0;
	}
	
	//
	function open() {
		setType(TOMB_OPEN);
		Game.me.addBonus(bdata.id);
		new fx.TombGlow(this);
	}
	
	//
	public function getNearestOpponent(ray) {
		var all = hex.getEnts(ray, 1);

		var dist = 9999.9;
		var opp:Ent = null;
		for ( e in all ) {
			var dx = x - e.x;
			var dy = y - e.y;
			var d  = Math.sqrt(dx * dx + dy * dy);
			if ( d < dist ) {
				opp = e;
				dist = d;
			}
		}
		return opp;
	}
		
	
	// life
	public function incLife(n) {
		life += n;
		
		hex.center(this);
		new fx.Shake(this, 0, 4);
		
		if ( life <= 0 ) {
			life = 0;
			hex.fxStone();	

			for ( nh in hex.nei ) if ( nh.is(TOMB) ) nh.building.open();
			Main.playSion("collapse",hex.level);
			destroy();
		}
		

	}	
	
	public function destroy() {
		if ( hex == Game.me.digTarget ) {
			hex.removeDigIcon();	
			Game.me.digTarget = null;
		}
		kill();
		seq.Play.me.majUndergroundDist();
		if( hex.border ) Game.me.victory = true;
	}

	override function kill() {
		hex.building = null;
		Game.me.buildings.remove(this);
		super.kill();
	}

	
//{
}






