import Lib;
import Protocol;
using MAll;


class Ent extends SP{//}
	
	public var alive:Bool;
	public var boots:Bool;
	
	public var hex:Hex;
	public var skin:EL;
	
	public var dx:Int;
	public var dy:Int;
	
	public var step:EntStep;
	
	var moveTrg:Hex;
	var prev:Bool;
	var tw:Tween;
	var moveCoef:Float;
	var endMove:Void->Void;
	var moveSpeed:Float;
	
	public var spawner:Building;
	
	
	var ammo:Int;	
	var timer:Int;	
	public var life:Int;	
	public var team:Int;
	public var data:DataEnt;
	public var wp:Hex;
	public var target:Ent;
	
	public var lvl:Level;
	
	public function new(id:EntType,hex) {
		super();
		alive = true;
		Game.me.ents.push(this);
		data = Data.ENTS[Type.enumIndex(id)];
		skin = new EL();
		skin.y = -8;
		addChild(skin);
		setFrame(0);

		ammo = 0;
		timer = 0;
		life = data.life;
		team = data.team;
		moveSpeed = data.speed / 1000;
		
		
		var n = Std.int(Hex.RAY * 2 / 3);
		dx = Std.random(2 * n) - n;
		dy = Std.random(2 * n) - n;
		x = dx;
		y = dy;		
		
		step = IDLE;
		setHex(hex);
		
		boots = Game.me.have(BOOTS);
		if ( data.id == GOBLIN ) Inter.me.majPrices();
		
		
	}
	
	public function setFrame(n) {
		skin.goto( Type.enumIndex(data.id)*24+n, "monsters");
	}
	

	// HEX

	public function setHex(h, center = true ) {
		
		leaveHex();
		
		hex = h;
		hex.ents.push(this);
		if( center ) hex.center(this);
		
		if ( lvl != hex.level ) {
			if ( lvl != null ) parent.removeChild(this);
			lvl = hex.level;
			lvl.dm.add(this, DP_ENTS);
		}
		
		
		if ( data.id == LICH ) majLichDist();
		
	}
	public function leaveHex() {
		if ( hex == null )  return;
		hex.ents.remove(this);
	}
	
	
	// UPDATE
	public function update() {
		timer++;
		
		if ( Main.t % 60 == 0 && data.id == ZOMBI ) {
			if ( Game.me.have(REGENERATION) && life < data.life ) heal(1);
		}
		
		
		switch(step) {			
			case IDLE :
				behave();
				
			case SPECIAL :
			case FIGHT :
			case MOVE :
				
				var heavy = data.id == GOBLIN && ammo >= 3;
				var spc = moveSpeed*Dev.BOOST_SPEED;
				if ( heavy ) spc *= 0.5;
				if ( boots && data.id == GOBLIN ) spc *= 2;
				//if ( Game.me.victory ) spc *= 2;
				
				moveCoef = Math.min(moveCoef + spc, 1);
				skin.scaleX = tw.ex - tw.sx > 0? 1:-1;
				

				var pos = tw.getPos(moveCoef);
				x = Std.int( pos.x );
				y = Std.int( pos.y );
						
				
				fxWalk(heavy);

				
				if ( moveCoef == 1 ) {
					step = IDLE;	
					if ( endMove != null ) {
						endMove();
						endMove = null;						
					}
				}
				
				
				
			case DIG :
				
				var lim = Std.int(40/Dev.BOOST_GOB_DIG);
				if ( timer < lim ) {
					setFrame(3);
				}else {

					setFrame( 3 + ((timer - lim) >> 1) );
					if ( timer - lim  == 4 ) {
						Main.playSion("pickaxe",hex.level);
						if( wp.building != null ) wp.building.incLife( -2*Dev.BOOST_GOB_DIG);

					}
					if ( timer - lim  == 11 ) {
						ammo++;
						timer = 0;
						if( !wp.is(STONES) || wp.digDist != 0 || ammo == 3){
							setFrame(0);
							step = IDLE;
						}
					}
				}			
		}
	}
	
	//

	// FX
	public function fxWalk(heavy=false) {
		var fr = [0, 1, 0, 2][(Main.t % 16) >> 2];
		if ( heavy ) fr += 9;
		setFrame(fr);		
	}
	
	// BEHAVE
	function behave() {
		switch( data.id ) {
			case GOBLIN :
								
				if ( ammo == 3 ) {
					var trg = null;
					for ( nh in hex.nei ) if ( nh.ladderDist < hex.ladderDist ) trg = nh;
					if ( trg == null ) {
						ammo = 0;
						Game.me.incRes(5);
						Main.playSion("ressource");
					}else {
						moveTo(trg);
					}

				}else {
					
					var a = [];	
					wp = null;
					for ( nh in hex.nei ) if ( nh.digDist < hex.digDist ) wp = nh;
					if ( wp == null ) {
						randomMove();
					}else {
						if ( wp.is(STONES) ) {
							step = DIG;
							timer = 0;
						}else {
							moveTo(wp);
						}
					}
				}
				
			case KNIGHT, PEASANT, SOLDIER :
				if ( hex.level.surface ) {
					
					var all = [];
					for ( nh in hex.nei ) if ( nh.castleDist < hex.castleDist ) all.push(nh);
					if ( all.length > 0 ) {						
						var trg  = all[Std.random(all.length)];
						moveTo(trg);
					}else {
						if ( hex.castleDist == 0 ) {
							invade();
						}else {
							randomMove();
						}
					}
					
					
				}else {
					hunt(40);
					if ( step == IDLE ) track( function(h) return h.lichDist );
					if ( step == IDLE ) randomMove();
				}
				
			case ZOMBI :
				hunt(96);
				if ( step == IDLE ) randomMove();
				
			case ORC :
				
				if ( Game.me.have( PATROL ) ) {
					if ( lvl.surface ) {
						
						if ( fx.Intrusion.ACTIVE ) {
							track( function(h) return h.castleDist, swapLevel );							
						}else {
							hunt(96);
							if ( step == IDLE ) {
								if ( hex.castleDist < 2 )		randomMove();
								else 							track( function(h) return h.castleDist );
							}
						}
						
					}else {						
						if ( fx.Intrusion.ACTIVE ) {
							hunt(96);
							if ( step == IDLE ) randomMove();
						}else {
							track( function(h) return h.ladderDist, swapLevel );							
						}
					}
					
				}else {
					hunt(96);
					if ( step == IDLE ) randomMove();
				}
				

				
				
			case LICH :
				if ( Game.me.victory ) {
					track( function(sq) return sq.escapeDist );
				}else {
					randomMove();
				}
				
				
				
				
			default :
		}
	}
	
	// COMMANDS
	function invade() {
		new fx.Intrusion();
		swapLevel();
	}
	function track(func,?goal ) {
		if ( goal!=null &&  func(hex) == 0 ) {
			goal();
			return;
		}
		var all = [];
		for ( nh in hex.nei ) if ( func(nh) < func(hex) ) all.push(nh);
		if ( all.length > 0 ) {						
			var trg  = all[Std.random(all.length)];
			moveTo(trg);
		}
		
	}
	function hunt(ray) {
		
		if ( Main.t % 40 == 0 || target == null ) target = getNearestOpponent(ray);
		if ( target != null && ( !target.alive || target.lvl != lvl || target.step == FIGHT ) ) target = null;
		
		if ( target != null ) {	
			if ( getDist(target) < 64 )	new fx.Fight( this, target);
			else 						follow(target,ray+1);
		}
	}
	function follow(trg:Ent,max) {
		Hex.propagate( trg.hex, function(h) return h.isFree(), max);
		for ( nh in hex.nei ) {
			if ( nh.temp < hex.temp ) {
				moveTo(nh);
				return;
			}
		}
	}
	
	// MOVE
	function randomMove() {
		var a = [];
		for ( nh in hex.nei ) if ( nh.isFree() ) a.push(nh);
		
		var hex = a[Std.random(a.length)];
		
		if ( spawner  != null ) {
			Hex.propagate(spawner.hex, function(h) return h.isFree(), 5 );
			if( hex.temp > 2 ) for ( h in a ) 	if ( h.temp < hex.temp ) hex = h;
		}
		
		
		if ( hex == null ) return;

		moveTo( hex );
		
	}
	public function moveTo(trg) {

		setHex(trg,false);	
		tw = new Tween( x, y, trg.tile.x + dx , trg.tile.y + dy  );
		
		step = MOVE;
		moveCoef = 0;	
		

	
		
	}
	function swapLevel() {
		var next = lvl.surface?Game.me.underground:Game.me.surface;
		setHex( next.getHex( hex.x,hex.y ) );
	}
	
	// TOOLS
	public function getNearestOpponent(ray) {
		if ( ray < 16 ) trace("!!!" + ray);
		var all = hex.getEnts(Math.ceil(ray/32), 1 - team);

		var dist = ray;
		var opp:Ent = null;
		for ( e in all ) {
			var d = Math.round( getDist(e) );
			if ( d < dist ) {
				opp = e;
				dist = d;
			}
		}
		return opp;
	}
	public function getDist(e:Ent) {
		var dx = e.x - x;
		var dy = e.y - y;
		return Math.sqrt(dx * dx + dy * dy);
	}
	public function heal(n) {
		new fx.Flash( this, 0x88FF88, 0.2);
		incLife(1);
		for ( i in 0...3 ) {
			var el = new EL();
			el.play("spark_heal");
			el.anim.gotoRandom();
			lvl.dm.add(el, DP_FX);
			var p = new fx.Part(el);
			p.setPos(x + Std.random(12) - 6, y - Std.random(8) - 2);
			p.vy = -Math.random();
			p.life = 12 + Std.random(20);
			p.onFinish = el.kill;
			
		}
	}
	
	// CARAC
	public function getDamage() {
		var n = data.atk;
		if ( data.id == LICH && Game.me.have( HEAVY_WAND ) ) n += 2;
		return n;
	}
	
	//DIST
	public function majLichDist() {
		var check = function(h) return h.isFree();
		Hex.propagate( hex, check );
		for ( h in Game.me.surface.grid ) h.lichDist = h.temp;
	}
	
	// HIT
	public function hit(n,vx=0.0,pierce=false) {
		
		if ( !pierce ) {
			n -= data.armor;
			if ( n <= 0 ) {
				n = 0;
				new fx.Flash(this, 0xFFFFFF, 0.15);
				Main.playSion("shield");
			}
		}
		
		
		if ( n > 0 ) {
			var e = new fx.Damage(n, hex.level);
			e.setPos(x, y - 12);
			e.vx += vx;
			new fx.Flash(this, 0xFF0000);
			if ( data.id == LICH ) Inter.me.maj();
			Main.playSion("ouch",hex.level);
			
		}
		incLife( -n);

		
	}
	public function incLife(n) {
		life += n;
		if ( life < 0 ) life = 0;
		if ( life == 0 ) {
			die();
		}
	}	
	
	function die() {
		var el = new EL();
		el.play("death");
		el.anim.onFinish = el.kill;
		el.x = x;
		el.y = y - 6;
		lvl.dm.add(el, DP_FX);
		kill();
	}
	
	function kill() {
		
		
		parent.removeChild(this);
		alive = false;
		leaveHex();
		Game.me.ents.remove(this);
		if ( spawner != null ) spawner.guardians.remove(this);
		if ( data.id == GOBLIN ) Inter.me.majPrices();
	}


	
//{
}






