import Lib;
import Protocol;
using MAll;

class Game extends SP {//}
	
	public static var WIDTH = 800 +400;
	public static var HEIGHT = 600+300;
	
	public var dynamite:Bool;
	public var victory:Bool;
	
	public static var me:Game;
	public var bg:SP;
	public var map:SP;
	public var screenEnt:SP;

	public var surface:Level;
	public var underground:Level;
	
	public var mineral:Int;
	
	public var mousePress:Bool;
	public var mouseClick:Bool;
	
	public var lockScroll:Int;	
	public var ents:Array<Ent>;
	public var buildings:Array<Building>;
	public var fxs:Array<Fx>;
	public var bonus:Array<BonusType>;
	public var castle:Building;
	public var lich:Ent;

	public var styk:Stykades;
	public var inter:Inter;
	
	public var digTarget:Hex;
	
	public function new() {
		super();
		dynamite = false;
		victory = false;
		Main.module = this;
		me = this;
		ents = [];
		buildings = [];
		fxs = [];
		bonus = [];
		mineral = 0;
		lockScroll = 0;
		hintSide = 1;
		
		bg = new SP();
		addChild(bg);
		bg.graphics.rect(0x4090C0, Game.WIDTH, Game.HEIGHT);
		
		
		map = new SP();
		addChild(map);
		
		inter = new Inter();
		addChild(inter);
		
		
		underground = new Level();
		underground.fill(DIRT);
		fillUnderground();

		map.addChild(underground);
		
		surface = new Level();
		surface.surface = true;
		fillSurface();
		map.addChild(surface);
		
		flash.Lib.current.stage.addEventListener( flash.events.MouseEvent.MOUSE_DOWN, mouseDown);
		flash.Lib.current.stage.addEventListener( flash.events.MouseEvent.MOUSE_UP, mouseUp);
		
		
		castle = new Building(CASTLE,surface.getHex(0, 0));
		lich = new Ent( LICH, underground.getHex(0, 0))  ;
	
		for ( i in 0...3 ) {
			var launch = function(){
				new Ent(GOBLIN,underground.getHex(0, 0) );
			}
			new fx.Wait(i * 6, launch);
		}
		
		styk = new Stykades();
		incRes(Gameplay.MONEY_START);
		new seq.Play();
		
		scrollTo( castle.hex );
		Inter.me.majPrices();
		
		
		for( id in Dev.TEST_FIGHT ) new Ent(id, surface.getHex( -1- Std.random(4), -1- Std.random(4) ) );

		for ( bt in Dev.TEST_BONUS ) addBonus(bt);
		
		Main.sion.play(haxe.Resource.getString("bg_music"));
		Main.sion.fadeIn(1);
	}
	
	function mouseDown(e) {
		mousePress = true;
		mouseClick = true;
	}
	function mouseUp(e) {
		mousePress = false;
	}

	//
	public function incRes(n) {
		mineral += n;
		Inter.me.maj();
	}

	// DIST
	public function majSurfaceDist() {
		
		var check = function(h) return h.isFree();
		Hex.propagate( Game.me.castle.hex, check );
		for ( h in Game.me.surface.grid ) h.castleDist = h.temp;
	}
	

	// HINT
	public var hint:EL;
	public var hintSide:Int;
	public function showHint(str,?title) {
		hideHint();
		
		var ww = 128;
		var hh = 80;			
		
		hint = new EL();
		hint.goto("hint_box",0,0);
		
		Game.me.addChild(hint);
		hint.x = Game.WIDTH - ww - 4;
		hint.y = 4;
		
	
		
		var field = Tools.getField(0xFFFFFF, "nokia");
		field.wordWrap = field.multiline = true;
		field.width = ww - 16;
		field.text = str;
		hint.addChild(field);
		Filt.glow( field, 2, 2, 0x442266);
		field.filters = [
			new flash.filters.GlowFilter(0x442288, 1, 2, 2, 2, 1),
			new flash.filters.DropShadowFilter(1, 90, 0x221144, 1, 0, 0, 4),
		];
		

		field.autosize();
		field.x = Std.int(ww - field.textWidth) >> 1;
		field.y = Std.int(hh - field.textHeight) >> 1;
		
		
		if ( title != null ) {
			var bg = new EL();
			bg.goto("hint_title");
			bg.x = ww >> 1;
			hint.addChild(bg);
			
			var f = Tools.getField(0xFFFFFF);
			f.text = title;
			f.autosize();
			f.x = Std.int(ww - f.textWidth) >> 1;
			f.y = -7;
			hint.addChild(f);
			Filt.glow(f, 2, 8, 0x444488);
			
			//var f = 
		}
		
		
		new fx.Call(moveHint);
		
	}
	public function hideHint() {
		if ( hint == null ) return;
		hint.parent.removeChild(hint);
		hint = null;
	}

	
	public function moveHint(e:Fx ) {
		if ( hint == null ) {
			e.kill();
			return;
		}
		
		hint.x = Std.int(flash.Lib.current.mouseX*0.5) + hintSide*32;
		hint.y = Std.int(flash.Lib.current.mouseY*0.5);
		
	}
	
	//
	public function onResize() {
		
	}
	
	// TOOLS
	public function getEnts(type) {
		var all = [];
		for ( e in ents ) if ( e.data.id == type ) all.push(e);
		return all;
	}
//
	public function kill() {
		Fx.ALL = [];
	}
	
	// BONUS
	public function addBonus(bt) {
		bonus.push(bt);
		switch(bt) {
			case DEAL : Inter.me.majPrices();
			case DYNAMITE : dynamite = true;
			case BOOTS : for ( e in ents ) e.boots = true;
			case GRAVEYARD_WALL :
				for ( b in buildings ) b.majData();
			default:
		}
	}
	public function have(bt) {
		for ( b in bonus ) if ( b == bt ) return true;
		return false;
	}
	public function numHave(bt) {
		var sum = 0;
		for ( b in bonus ) if ( b == bt ) sum++;
		return sum;		
	}
	// GENERATOR
	public function fillUnderground() {
		
		
		Hex.propagate( underground.getHex(0, 0), function(h) return true);
		
		var dirt = [];
		for ( h in underground.grid ) if ( h.temp > 1 && h.tile.visible ) dirt.push(h);
		
		dirt.shuffle(); 
		
		for ( data in Data.BONUS ) {
			for( i in 0...data.max ){
				var h = dirt.pop();
				if ( h.temp == 2 || h.border ) {
					dirt.unshift(h);
					continue;
				}
				h.setType(DIRT);
				var b = new Building( TOMB, h );
				b.bdata = data;
			}
		}
		
		//
		for ( h in dirt ) new Building( STONES, h);
		
		if ( Dev.TEST_ESCAPE ) {
			for ( i in 0...Level.RAY ) {
				var h = underground.getHex(i, 0);
				if( h.building != null ) h.building.kill();
			}
		}

		
		
		
	}
	
	public function fillSurface() {
		
		
		Hex.propagate( surface.getHex(0, 0), function(h) return true);
		
		var all = [];
		for ( h in surface.grid ) if ( h.temp > 2 && !h.border && h.tile.visible ) all.push(h);
		
		all.shuffle(); 
		
		for ( i in 0...Level.RAY*2 ) {
			var h = all.pop();
			new Building(TREE, h);
		}
		
		
		
		
	}
		
	public function scrollTo(hex:Hex,?onFinish) {
		lockScroll++;
		var pos = hex.getPos();
		var autoScroll = new fx.Move( Game.me.map, (Main.mcw * 0.5) - pos.x, (Main.mch * 0.5) - pos.y, 0.05 );
		autoScroll.curveInOut();
		autoScroll.onFinish = function() {
			lockScroll--;
			if ( onFinish != null ) onFinish();
		}
	
	}
	
//{
}






