import Lib;
import Protocol;
using MAll;

class Level extends SP {//}
	

	public static var RAY = 11;
	public var grid:Array<Hex>;
	public var dm:DepthManager<LevelDepth>;
	public var surface:Bool;
	
	public function new() {
		super();
		surface = false;

		dm = new DepthManager(this, LevelDepth);
		
		grid = [];
		var max = RAY * 2 + 1;
		for ( x in 0...max ) {
			for ( y in 0...max ) {
				var hex = new Hex(this, x-RAY, y-RAY);
				hex.setType(GRASS);
				hex.border = Math.abs(hex.x) == RAY || Math.abs(hex.y) == RAY || ( Math.abs(hex.x-hex.y) == RAY && hex.x!= 0 && hex.y!= 0 ); 
				grid.push(hex);				
				if ( Math.abs(hex.x - hex.y) > RAY ) hex.tile.visible = false;
			}
		}
		
		for ( h in grid ) {
			for ( d in Hex.DIR ) {
				var nx = h.x + d[0];
				var ny = h.y + d[1];
				if ( isIn(nx, ny) ) {
					var nh = getHex(nx, ny);
					h.nei.push(nh);
					h.dnei.push(nh);
				}else {
					h.dnei.push(null);
				}
				
				
			}
		}
		
		
		
		blendMode = flash.display.BlendMode.LAYER;
	}
	
	public function isIn(x,y) {
		return x >= -RAY && x <= RAY && y >= -RAY && y <= RAY && Math.abs(x - y) <= RAY;
	}
	
	public inline function getHex(x, y) {
		return grid[(x+RAY) * (RAY * 2 + 1) + (y+RAY)];		
	}

	public function fill(t) {
		for ( hex in grid ) hex.setType(t);
	}

	public function getHexAt(x:Float,y:Float) {
		var py = (y - (Game.HEIGHT >> 1)) / 24;
		var px = (x-( (Game.WIDTH >> 1) - 16 * py ) )/32;
		return getHex(Math.round(px), Math.round(py));
	}
	
	
	public function checkHole(trg:Hex) {
	

		var center = getHex(0, 0);
		var work = [ center ];
		center.temp = 0;	
		
		var a = Hex.propagate(center, function(h) return h.isFree() && !h.is(GRAVEYARD) && h != trg,9999);
		

		var sum = 0;
		for ( h in grid )  if (  h.temp == 9999 && h.isFree() && h.tile.visible && h!=trg) sum++;

		return sum == 0;
		
	}
	
	
	
//{
}






