
@:build(ods.Data.build("data.ods", "buildings", "id")) enum BuildingType { }
@:build(ods.Data.build("data.ods", "ents", "id")) enum EntType { }
@:build(ods.Data.build("data.ods", "bonus", "id")) enum BonusType { }



typedef EL = pix.Element;




class Dev {
	
	public static var SFX = true;
	
	public static var FINAL = true;	
	
	public static var TEST_GAME = false;
	
	public static var BOOST_GOB_DIG = 1;
	public static var BOOST_SPEED = 1;
	
	public static var START_SOLDIER = 0;	

	
	public static var TEST_FIGHT = [];
	public static var TEST_BONUS = [];
	public static var TEST_ESCAPE = false;

	
}

class Gameplay {
	public static var MONEY_START = 80;	
	public static var BLOCK_LIFE = 80;
}


class Def {

}


class Data {
	
	public static var MUSIC = haxe.Resource.getString("bg_music");
	public static var BUILDINGS = ods.Data.parse("data.ods", "buildings", DataBuilding );
	public static var ENTS = ods.Data.parse("data.ods", "ents", DataEnt );
	public static var BONUS = ods.Data.parse("data.ods", "bonus", DataBonus );
	
}


typedef DataBuilding = {
	id:BuildingType,
	price:Int,
	cooldown:Int,
	damage:Int,
	fam:BuildingFam,
	spawn:Null<EntType>,
	range:Int,
	desc:Null<String>,
}
typedef DataEnt = {
	id:EntType,
	name:Null<String>,
	desc:Null<String>,
	life:Int,
	atk:Int,
	team:Int,
	speed:Int,
	armor:Int,
	price:Int,
}
typedef DataBonus = {
	id:BonusType,
	name:String,
	desc:String,
	max:Int,
}

enum BuildingFam {
	BT_BASE;
	BT_SHOOT;
	BT_SPAWN;
}
enum HexType {
	 
	DIRT;
	WALLA;
	GRASS;
	
}

enum LevelDepth {
	DP_HEX;
	DP_ENTS;
	DP_FX;
}
enum EntStep {
	IDLE;
	MOVE;
	SPECIAL;
	DIG;
	FIGHT;
}




