package seq;
import Lib;
import Protocol;
using MAll;

class Escape extends Fx {//}
	

	
	var trg:Hex;
	var panel:SP;
	
	public function new() {
		super();

		Main.clearButs();
		

		for ( h in Game.me.underground.grid ) if ( h.building == null && h.border ) trg = h;
		Hex.propagate( trg, function(h) return h.isFree());
		for ( h in Game.me.underground.grid ) h.escapeDist = h.temp;
		
		
		Game.me.lich.step = IDLE;
		
	}
	
	override function update() {
		super.update();
		switch(step) {
			case 0 :
				
				Play.me.majSlide();
				Game.me.lich.update();
				
				var pos = trg.getPos();
				var dx = Game.me.lich.x - pos.x;
				var dy = Game.me.lich.y - pos.y;
				
				var dist = Math.sqrt(dx * dx + dy * dy);
				
				Col.setColor(Main.screen, 0,  Std.int(dist*3 - 255).clamp( -255, 0));
				
				if ( dist < 16 ) init();
				scroll();
			case 1 :
				Col.setColor(Main.screen, 0,  -Std.int(255 * (1 - coef)));
				
				var id = (Main.t%16) >> 2;
				lich.goto(Type.enumIndex(LICH)*24 + [0,1,0,2][id],"monsters");
				
				lich.x += 2;
				
				if ( timer == 120 && desc.length > 0 ) spawnDesc();
				
				
		
		}
		
	}
	
	var lich:EL;
	var cy:Int;
	var desc:Array<String>;
	
	function init() {
		Main.sion.fadeOut(1);
		//0x4B2B12
		panel = new SP();
		panel.graphics.rect(0, Main.mcw, Main.mch);
		Game.me.addChild(panel);
		
		lich = new EL();

		panel.addChild(lich);
		lich.x = -24;
		lich.y = Std.int(Main.mch)  >> 1;
		
		
		var f = Tools.getField(0xFFFFFF, "emulogic", 8);
		f.htmlText = "congratulations!".color(0xcc88FF);
		f.autosize();
		f.x = Std.int(Main.mcw -f.textWidth) >> 1;
		f.y = Main.mch >> 3;
		panel.addChild(f);
		
		desc = [
			"You escaped the naughty humans.",
			"Let's search for a new place to build your evil tower..."
		];
		cy = Std.int( f.y + 16 );
		/*
		var desc = Tools.getField(0xCCCCCC, "emulogic", 8);
		desc.wordWrap = true;
		desc.multiline = true;
		desc.width = Main.mcw * 0.75;
		desc.autosize();
		desc.x = Std.int(Main.mcw -f.textWidth) >> 1;
		
		panel.addChild(desc);
		*/
		Main.makeBut(panel, exit);
		nextStep();
	}
	
	function spawnDesc() {
		
		var f = Tools.getField(0xAAAAAA, "emulogic", 8);
		f.text = desc.shift();
		f.width = Main.mcw * 0.85;
		f.wordWrap = true;
		f.multiline = true;
		f.autosize();
		f.x = Std.int(Main.mcw -f.textWidth) >> 1;
		f.y = cy;
		cy += Std.int( f.textHeight + 8 );
		panel.addChild(f);
		
		var e = new fx.Fade(f, true, 0);
		e.spc = 0.01;
		
		timer = 0;
	}
	
	function exit() {
		Main.clearButs();
		var e = new fx.Fade( panel, false, 0);
		e.spc = 0.02;
		e.onFinish = end;
	}
	
	function end() {
		kill();
		new Menu();
	}
	
	function scroll() {
		
		var lich = Game.me.lich;

		var tx = (Main.mcw * 0.5) - lich.x;
		var ty = (Main.mch * 0.5) - lich.y;
		
		var co = 0.2;
		Game.me.map.x += (tx - Game.me.map.x) * co;	
		Game.me.map.y += (ty - Game.me.map.y) * co;	
		
		Game.me.map.x = Std.int(Game.me.map.x);
		Game.me.map.y = Std.int(Game.me.map.y);
	}
	
	
//{
}





