package seq;
import Lib;
import Protocol;
using MAll;

class Play extends Fx {//}
	

	public var surfaceActive:Bool;
	
	public var slideCoef:Float;
	public var cur:Hex;
	public var lvl:Level;
	public var underGroundZone:Array < Hex >;
	public var Ents:Array<ui.Card>;
	public var bars:Array<SP>;
	
	public static var me:Play;
	
	var pressTime:Int;
	var pressPos: { x:Float, y:Float };
	public var svx:Float;
	public var svy:Float;	
	var scrolling:Bool;
	
	public function new() {
		super();
		me = this;
		surfaceActive = true;
		slideCoef = 0;
		underGroundZone = [];
		Ents = [];
		for ( hex in Game.me.underground.grid ) if ( hex.type == DIRT ) underGroundZone.push(hex);
		majUndergroundDist();
		Game.me.majSurfaceDist();

		svx = 0;
		svy = 0;
		
		/*
		bars = [];
		for (i in 0...2 ) {
			var bar = new SP();
			Game.me.addChild(bar);
			bars.push(bar);
			if ( i == 0 ) {
				var but = new ui.RoundBut();
				but.setBuilding(GRAVEYARD);
				but.setBuilding(ARCHER);
				but.setBuilding(SORCERER);
				
				
			}else {
				
			}
		}
		*/
		
		
		
		
	}
		
	
	
	override function update() {
		super.update();
		
		Game.me.styk.update();
	
		// SLIDE
		majSlide();
		
		// CUR		
		if ( lvl != null ) {
			var mp = getMousePos();
			var ncur = lvl.getHexAt(mp.x, mp.y );
			if ( scrolling ) ncur = null;
			if ( !lvl.surface && flash.Lib.current.mouseX < 96 ) ncur = null;
			
			if ( ncur != cur ) {
				if( cur != null ) cur.rollOut();
				cur = ncur;
				if( cur != null ) cur.rollOver();				
			}
		}

		// ENTS
		for ( e in Game.me.ents ) 		e.update();
		for ( b in Game.me.buildings ) 	b.update();
		for ( e in Game.me.fxs ) 		e.update();
		
		// PRESS SCROLL
		//trace(scrolling+" "+Math.sqrt(svx * svx + svy * svy));
		if ( pressPos == null  ) {
			if ( Game.me.mousePress ) {
				pressPos = getMousePos();
				pressTime = Main.t;
			}
			
			var frict = 0.9;
			svx *= frict;
			svy *= frict;
			
		}else {
			if ( !scrolling ) scrolling = Main.t - pressTime > 10 || Math.sqrt(svx * svx + svy * svy) > 4 ;
			
			var mp = getMousePos();
			svx = mp.x - pressPos.x;
			svy = mp.y - pressPos.y;
			if ( !Game.me.mousePress ) {
				if (  !scrolling  ) tap();
				pressPos = null;				
				scrolling = false;
			}else {
				
			}
		}

		var tw = flash.Lib.current.stage.stageWidth;
		var th = flash.Lib.current.stage.stageHeight;		
		var dw = Game.WIDTH * 2 - tw;		
		var dh =  Game.HEIGHT * 2 -th;
		if ( Game.me.lockScroll == 0 ) {
			Game.me.map.x = Std.int((Game.me.map.x + svx).fclamp(-dw,0));
			Game.me.map.y = Std.int((Game.me.map.y + svy).fclamp( -dh * 0.5, 0));
		}
		
		//
		if ( Main.t % 40 == 0 && Game.me.have(STENCH) ) stench();
		
		// Z SORT
		zSort();

		
		
		//
		Game.me.mouseClick = false;
		
		// CHECK END GAME
		if ( Game.me.lich.life == 0 ) {
			kill();
			new seq.GameOver();
		}else if ( Game.me.victory ) {
			kill();
			new seq.Escape();
		}
		
	}
	
	public function zSort() {
		var a:Array<{x:Float,y:Float,hex:Hex}> = [];
		for ( e in Game.me.ents ) 		a.push(e);
		if(Main.t%40==0) for ( b in Game.me.buildings ) 	a.push(b);
		a.sort( function(a, b) return a.y < b.y? -1:1 );
		for ( o in a ) o.hex.level.dm.add(cast o, DP_ENTS );
	}
	
	public function tap() {

		if (  cur != null ) {
			var bt = cur.getBuildingType();
			if ( bt == CASTLE || bt == LADDER ) {
				surfaceActive = !surfaceActive;
				Main.playSion( surfaceActive?"climb_up":"climb_down");
			}
			else if ( cur.is( STONES ) ) {
				if ( Game.me.dynamite ) {
					Game.me.dynamite = false;
					cur.blowUp();
					Main.playSion("collapse");
				}else{
					toggleTarget(cur);					
				}
				cur.rollOut();
			}
			else if ( cur.type == GRASS ) {
				if ( Game.me.surface.checkHole(cur) ) {
					build(cur);
				}else {
					Main.playSion("wrong");
				}
				
			}
			
		}		
	}
	
	//
	public function majSlide() {
		lvl = null;

		var inc = 0.15;

		if ( !Game.me.victory ) {
			if (  !Keyb.isDown(flash.ui.Keyboard.SPACE) ) inc = -inc;
			if (  !surfaceActive ) inc = -inc;
				
		}
		


		
		slideCoef = (slideCoef + inc).fclamp(0, 1);

		var c = Math.pow(slideCoef,2);
		var slideHeight = 60;
		
		Game.me.surface.y = -slideHeight * c;
		Game.me.surface.alpha = 1-c;
		Game.me.surface.visible = c < 1;
		
		
		
		
		var c = Math.pow(slideCoef,0.5);
		Game.me.underground.y = slideHeight * (1-c);
		Game.me.underground.alpha = c;
		Game.me.underground.visible = c > 0;

		Inter.me.summonMenu.x = (c-1) * 64;
		Game.me.bg.setColor(0x440000, c);
		
		if ( slideCoef == 0 ) lvl = Game.me.surface;
		if ( slideCoef == 1 ) lvl = Game.me.underground;
		
		var undergound = lvl != null && !lvl.surface;
		if ( undergound && !Inter.me.underGroundMode ) Inter.me.activeUnderground();
		if ( !undergound && Inter.me.underGroundMode ) Inter.me.deactiveUnderground();
		

	}
	

	function getMousePos() {
		return {
			x:flash.Lib.current.mouseX * 0.5 - Game.me.map.x,
			y:flash.Lib.current.mouseY * 0.5 - Game.me.map.y,			
		}
	}
	
	//
	// COMMANDS
	function toggleTarget(target:Hex) {
		
		if ( Game.me.digTarget != null ) Game.me.digTarget.removeDigIcon();
		
		Main.playSion("build_ok");
		
		Game.me.digTarget = target;
		Game.me.digTarget.setDigIcon();
		/*
		if ( target.sel != null ) {
			targets.remove(target);
			target.hideSelector();
		}else {
			target.showSelector();
			targets.push(target);
		}
		*/
		

		majUndergroundDist();
		
		
		/*
		// CLEAN
		for ( h in path ) h.hideSelector();
		path = [];
		
		
		// SEEK
		for ( h in Game.me.underground.grid )	h.temp = 999;
		
		var work = underGroundZone.copy();
		
		for ( h in work ) h.temp = 0;
		
		while ( work.length > 0 ) {			
			var h = work.shift();
			for ( nh in h.nei ) {
				if ( nh.temp <= h.temp+1 ) continue;
				nh.temp = h.temp + 1;
				work.push(nh);
			}			
		}
		

		var trg = target;		
		while ( trg.type != DIRT ) {
			 path.unshift(trg);			 
			 for ( nh in trg.nei ) if ( nh.temp < trg.temp ) trg = nh;
		}
		
		for ( h in path ) h.showSelector();

		*/
		

	}

	function build(target) {
		kill();
		new seq.SelectBuild(target);
	}
	
	// DIST
	public function majUndergroundDist() {
		var lvl  = Game.me.underground;
		
		for ( h in lvl.grid ) {
			h.ladderDist = 99999;
			h.digDist = 99999;
			
		}
		
		// LADDER
		Hex.propagate( lvl.getHex(0, 0), function(h) return h.isFree());
		for ( h in lvl.grid ) h.ladderDist = h.temp;
		/*
		var ladder = lvl.getHex(0, 0);
		ladder.ladderDist = 0;		
		var work = [ladder];
		while (work.length > 0 ) {
			var h = work.shift();
			for ( nh in h.nei ) {
				if ( nh.type != DIRT || nh.ladderDist <= h.ladderDist ) continue;
				nh.ladderDist = h.ladderDist + 1;
				work.push(nh);
			}
		}
		*/

		
		// DIG DIST
		var work = [];
		if ( Game.me.digTarget != null ) work.push(Game.me.digTarget);
		for ( h in work ) h.digDist = 0;
		
		while ( work.length > 0 ) {	
	
			var h = work.shift();
			for ( nh in h.nei ) {
				var inc = nh.isFree()?1:10;
				if ( nh.digDist <= h.digDist + inc ) continue;				
				nh.digDist = h.digDist + inc;				
				work.push(nh);
			}			
		}
		
		
		
	}
	

	// SPECIFIC
	public function stench() {
		
		var all = [];
		var ents = [];
		for ( h in Game.me.surface.grid ) {
			h.temp = 0;
			if ( h.is( GRAVEYARD ) ) all.push(h);
		}
		
		for ( h in all ) for ( nh in h.nei ) nh.temp = 1;
		for ( h in Game.me.surface.grid ) {
			if ( h.temp == 0 ) continue;
			for ( e in h.ents ) ents.push(e);
		}
		

		
		for ( e in ents ) if ( e.team == 1 ) {
			
			new fx.Fade(e.skin, true, 0x008800);
			
			var el = new EL();
			el.play("gas");
			el.randomFlip();
			
			var p = new fx.Part(el);
			el.anim.onFinish = el.kill;
			p.setPos( e.x + Std.random(7) - 3, e.y - 6 - Std.random(8) );
			p.vy = -Math.random();
			
			e.hex.level.dm.add(el, DP_FX);
			
			e.hit(1, 0, true);
		}
	
	}
	
	// KILL
	override function kill() {
		if ( cur != null ) cur.rollOut();
		super.kill();
	}
	
	/// DEPREC
	public function autoScroll() {

		var tw = flash.Lib.current.stage.stageWidth;
		var th = flash.Lib.current.stage.stageHeight;		
		var cx = flash.Lib.current.mouseX / tw;
		var cy = flash.Lib.current.mouseY / th;
		var dw = tw - Game.WIDTH * 2;
		var dh = th - Game.HEIGHT * 2;				
		Game.me.map.x = Std.int(dw * cx)>>1;
		Game.me.map.y = Std.int(dh * cy) >> 1;
			
	}

//{
}





