package seq;
import Lib;
import Protocol;
using MAll;

class SelectBuild extends Fx {//}
	

	var buts:Array<ui.RoundBut>;
	var hex:Hex;
	var ring:EL;
	var sel:EL;
	var content:SP;
	var back:SP;
	
	
	
	public function new(trg) {
		super();
		hex = trg;
		buts = [];
		
		back = new SP();
		Game.me.map.addChild(back);
		
		content = new SP();
		hex.center(content);
		Game.me.map.addChild(content);
		
		sel = new EL();
		sel.goto("build_selector");
		sel.y += 4;
		content.addChild(sel);		
		
		ring = new EL();
		ring.goto("giant_ring");		
		ring.scaleX = ring.scaleY = 0;
		content.addChild(ring);
		
		var all = [GRAVEYARD, ARCHER, SORCERER];
		
		for ( bid in all ) {
			var but = new ui.RoundBut();
			but.setBuilding(bid);
			content.addChild(but);
			buts.push(but);
			new fx.Flash(but.bg, 0xFFFFFF, 0.08);
			new fx.Flash(but.icon, 0xFFFFFF, 0.06);
		}
		
		spc = 0.08;
		curveIn(0.5);
		
		Game.me.scrollTo(hex, initButs);
		
		Main.playSion("build_in");
	}
	

	
	override function update() {
		super.update();
		
		sel.alpha = 0.5 + Math.cos(timer.cmod(18) * 6.28) * 0.5;
		switch(step) {
			case 0 :
				var c = curve(coef);
				spawn(c);
		
				if ( coef == 1 ) nextStep();
			case 1 :
			case 2 :
				var c = curve(1-coef);
				spawn(c);
				if ( coef == 1 ) {
					Game.me.map.removeChild(content);	
					kill();
					
				}
				
				
		}
	}
	
	function spawn(c:Float) {
		
		var ray = 64;
		for ( i in 0...buts.length ) {
			var but = buts[i];
			var an = i * 6.28 / buts.length + c * 3.14;
			but.x = Math.cos(an) * c * ray;
			but.y = Math.sin(an) * c * ray;
			//but.scaleX = but.scaleY = Math.pow(c,0.5);
			but.setColor(0xFFFFFF, 1 - Math.pow(c,2));
			but.pxx();
		}
		ring.scaleX = ring.scaleY = c;

	}
	
	function initButs() {


		back.graphics.rect(0, Game.WIDTH, Game.HEIGHT);
		back.alpha = 0;

		Main.makeBut( back, cancel );
		for ( b in buts ) {
			Main.makeBut( b, select.bind(b), b.rover, b.rout );
		}
	}
	
	function cancel() {
		Main.playSion("build_out");
		leave();
	}
	
	function leave() {
		Game.me.hideHint();
		Main.clearButs();
		nextStep();
		step = 2;
		onFinish = function() new Play();
	}
	
	function select(b:ui.RoundBut) {
		
		var price = b.dataBuilding.price;
		
		if ( price > Game.me.mineral ) {
			
			new fx.Shake( b, 8, 8 );
			Main.playSion("wrong");
			
		}else {
			Main.playSion("build_ok");
			leave();		
			onFinish = function() {
				Game.me.incRes( -price );
				new fx.Build(b.dataBuilding.id, hex);
				Game.me.majSurfaceDist();
				new Play();
			}
		}
		

	}

//{
}





